# -*- coding: utf-8 -*-
import sys

from numpy import array, zeros, inner
from numpy.linalg import norm

def force(p1, p2):
    '''
    Kraftberechnung zwischen zwei Partikeln beim stellaren Beispiel
    Rückgabe der potentiellen Energie
    '''

class Particle:
    def __init__(self, m, x, v, F=((0.,0.)), F_old=((0.,0.)), number=None ):
        self.mass = float(m) # Masse
        self.x = array(x, float) # Ort
        self.v = array(v, float) # Geschwindigkeit
        self.F = array(F, float) # Kraft zum aktuellen Zeitschritt
        self.F_old = array(F_old, float) # Kraft zum vorherigen Zeitschritt
        if not number is None:
            self.number = number

    def update_x(self, delt):
        '''bewegt das Partikel'''

    def update_v(self, delt):
        '''update der Geschwindigkeiten, Rückgabe der kinetischen Energie'''


class Problem:
    def __init__(self, filename):
        self.particle_count = 0
    
	def read_particles(self, filename):
        self.particles = []
        particle_file = open(filename, 'r')
        for particle_line in particle_file:
            fields = particle_line.split()
            if len(fields) == 5:
                self.particle_count += 1
                particle = Particle(fields[0], fields[1:3], fields[3:5], number=self.particle_count)
                self.particles.append(particle)
            else:
                raise ValueError, len(fields)
        particle_file.close()

    def write_particles(self, file, mass=False, velocity=False):
        for particle in self.particles:
            if mass:
                output = '%g\t' % particle.mass
            else:
                output = ''
            for i in particle.x:
                output += '%f \t' % i
            if velocity:
                for i in particle.v:
                    output += '%f \t' % i
            output += '\n'
            file.write(output)

    def write_particles_vmd(self, file, time):
        output = '%d\ntime = %f\n' % (len(self.particles), time)
        file.write(output)
        for particle in self.particles:
            output = '%s ' % particle.number
            for i in particle.x:
                output += '%g ' % i
            output += '\n'
            file.write(output)
        
    def comp_forces(self):
        '''Berechnung der Kräfte, Rückgabe der potentiellen Energie'''

inp = sys.argv[1]
problem = Problem(inp)
